////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//	-You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////
function RandomSquareGenerator(phaser, game){
	
	var th_ = this;
	
	var graphics;
	
	this.x = 0;
	this.y = 0;
	
	this.rectangles = [];
	
	var timedEvent;
	
	var nRows = 10;
	var nCols = 18;
	
	var cellSize = 30;
	
	
	
	this.create = function(){
		
		graphics = phaser.add.graphics({x: 0, y: 0});
		
	}
	
	function onCompleteHandler(tween, targets, arg){
		
		for (var i = 0; i < th_.rectangles.length; ++i){
			
			var rect = th_.rectangles[i];
			
			if(rect == arg){
				th_.rectangles.splice(i, 1);
			}

		}
		
	}
	
	this.start = function(){
		
		
		

		
		th_.totalWidth = nCols * cellSize;
		th_.totalHeight = nRows * cellSize;
		
		th_.x = (game.canvas.width - th_.totalWidth) * 0.5;
		th_.y = (game.canvas.height - th_.totalHeight) * 0.5;
		
		for(var i = 0; i < nRows; i++){
			
			var y = i * cellSize;
			
			for(var j = 0; j < nCols; j++){
				
				var x = j * cellSize;
				
				var rec = new Square();
				rec.x = x;
				rec.y = y;
				rec.width = cellSize;
				rec.height = cellSize;
				
				th_.rectangles.push(rec);
				
			}
			
		}
		
		for(var i = 0; i < th_.rectangles.length; ++i){
			
			var rec = th_.rectangles[i];
			
			var delay = i * 10;
			phaser.tweens.add({
				targets: rec,
				width: 0,
				height: 0,
				ease: 'Power1',
				duration: 3000,
				delay: delay,
				repeat: -1,
				yoyo: true
			});
			
		}
		
	}
	

	
	this.update = function(){
		
		graphics.clear();
    
		for (var i = 0; i < th_.rectangles.length; ++i){
			
			var rect = th_.rectangles[i];
			graphics.fillStyle(0x000000, rect.fillAlpha);
			graphics.lineStyle(4.0, 0xFF0000, rect.strokeAlpha);
			
			var x = rect.x;
			var y = rect.y;
			var w = rect.width;
			var h = rect.height;
			var hw = w / 2;
			var hh = h / 2;
			
			graphics.save();
			graphics.translate(th_.x + x, th_.y + y);
			graphics.rotate(rect.rotation);
			
			graphics.fillRect(-(rect.width * rect.scale) / 2, -(rect.height * rect.scale) / 2, w * rect.scale, h * rect.scale);
			
			
			
			graphics.restore();
			//graphics.strokeRect(x, y, w, h);

		}
	}
	
}

function Square(){
	
	this.type = 0;
	
	this.x = 0;
	this.y = 0;
	this.width = 5;
	this.height = 5;
	this.scale = 1;
	this.rotation = 0;
	this.fillAlpha = 1;
	this.strokeAlpha = 1;
}